#ifndef BREED_H
#define BREED_H

#include <eo>
#include <iostream>   // cout
#include <iomanip>

using namespace std; 



class MyBreed : public eoBreed<Indi> {

public:

  
  MyBreed(vector<string>& _stratNames) : stratNames(_stratNames) {};

  virtual void operator()(const eoPop<Indi>& _source, eoPop<Indi>& _dest) {
       
    vector<double> fitnesses; 
    fitnesses.resize( _source.size() );
    
    double total = 0; 
    for (unsigned i=0; i<fitnesses.size(); i++) {
      fitnesses[i] = _source[i].fitness();
      total += fitnesses[i]; 
    }
    
    _dest.resize( _source.size() );


    // do roulette-wheel     
    for (unsigned i=0; i<_dest.size(); i++) { 
      _dest[i] = _source[ select_one(fitnesses,total) ]; 
      if (rng.flip(0.2)) {
	_dest[i].set( stratNames[ rng.random( stratNames.size() ) ] );
	_dest[i].invalidate();
      }
    }

  }

  
  unsigned select_one(const vector<double>& _fit,double total) {
 
    double rnd = rng.uniform(total); 
    unsigned i=0;
	  
    while (i<_fit.size() && _fit[i]<=rnd) {
      rnd -= _fit[i];
      i++; 
    } 

    if (i<_fit.size()) 
      return i; 
    else
      throw std::runtime_error("select_on: total fitness not valid");
  }    


  private:
  vector<string>& stratNames; 
  

};  

#endif
